<?php
/**
 *
 * Auther: heyu
 * DateTime: 2020-01-03 15:01
 *
 */

namespace kwy\wechatapi\pay;


use kwy\util\http\CurlHttp;

class WechatPay extends ApiRequest
{

    private $mch_id='';

    private $appid='';

    private $sub_mch_id='';

    private $key='';

    /**
     * @param string $appid
     */
    public function setAppid($appid)
    {
        $this->appid = $appid;
    }

    /**
     * @param string $mch_id
     */
    public function setMchId($mch_id)
    {
        $this->mch_id = $mch_id;
    }

    /**
     * @param string $key
     */
    public function setKey($key)
    {
        $this->key = $key;
    }

    /**
     * @param string $sub_mch_id
     */
    public function setSubMchId(string $sub_mch_id)
    {
        $this->sub_mch_id = $sub_mch_id;
    }

    public function microPay($no,$total_fee,$auth_code,$body){
        $url='https://api.mch.weixin.qq.com/pay/micropay';
        $params=[
            'appid'=>$this->appid,
            'mch_id'=>$this->mch_id,
            'sub_mch_id'=>$this->sub_mch_id,
            'nonce_str'=>$this->getNonceStr(16),
            'sign_type'=>'MD5',
            'body'=>$body,
            'out_trade_no'=>$no,
            'total_fee'=>$total_fee,
            'spbill_create_ip'=>'115.29.165.48',
            'auth_code'=>$auth_code,
        ];

        $params['sign']=$this->getSign($params,$this->key);

        $this->getHttp()->setUrl($url);
        $xml=$this->getHttp()->post($this->toXml($params));
        return json_decode(json_encode(simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
    }

    public function query($no){
        $url='https://api.mch.weixin.qq.com/pay/orderquery';
        $params=[
            'appid'=>$this->appid,
            'mch_id'=>$this->mch_id,
            'sub_mch_id'=>$this->sub_mch_id,
            'nonce_str'=>$this->getNonceStr(16),
            'sign_type'=>'MD5',
            'out_trade_no'=>$no,
        ];

        $params['sign']=$this->getSign($params,$this->key);

        $this->getHttp()->setUrl($url);
        $xml=$this->getHttp()->post($this->toXml($params));

        return json_decode(json_encode(simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
    }
}